
/*
 * COPYRIGHT INFORMATION - DO NOT REMOVE
 * "Portions Copyright (c) 2000-2001 LinuxMagic Inc. All Rights Reserved.
 *
 * This file contains Original Code and/or Modifications of Original Code as
 * defined in and that are subject to the Free Source Code License Version
 * 1.0 (the 'License'). You may not use this file except in compliance with
 * the License. Please obtain a copy of the License at:
 *
 * http://www.linuxmagic.com/opensource/licensing/
 *
 * and read it before using this file.
 *
 * The Original Code and all software distributed under the License are
 * distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND LINUXMAGIC HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT. Please see
 * the License for the specific language governing rights and limitations
 * under the License."
 *
 * Please read the terms of this license carefully. By using or downloading
 * this software or file, you are accepting and agreeing to the terms of this
 * license with LinuxMagic Inc. If you are agreeing to this license on behalf
 * of a company, you represent that you are authorized to bind the company to
 * such a license. If you do not meet this criterion or you do not agree to
 * any of the terms of this license, do NOT download, distribute, use or alter
 * this software or file in any way.
 *
 * Author: Burton Samograd (burton@wizard.ca)
 * CVS Id: $Id: smtp_checks.c,v 1.3 2002/11/21 23:30:18 burton Exp $
 *
 * DO NOT MODIFY WITHOUT CONSULTING THE LICENSE
 */


/* C includes */
#include <stdlib.h>

/* System includes */
#include <unistd.h>
#include <netdb.h>


#include <netinet/in.h>
#include <arpa/nameser.h>
#include <resolv.h>

/* lmlibs */
#include <liblm.h>

/* lmsmtpd includes */
#include "smtp_checks.h"
#include "lmsmtpd_config.h"

int smtp_check_valid_domain(lm_string_t domain)
{
	char buffer[1024];
	int retval;

	retval = res_init();

	retval = res_query(LM_STRING_BUFFER(domain), C_IN, T_A, buffer, sizeof(buffer));
	if(retval == -1)
		retval = res_query(LM_STRING_BUFFER(domain), C_IN, T_MX, buffer, sizeof(buffer));

	return retval == -1;
}

int smtp_check_valid_helo_domain(lm_string_t domain)
{
	return smtp_check_valid_domain(domain);
}

int smtp_check_from_valid_domain(lm_string_t domain)
{
	return smtp_check_valid_domain(domain);
}

int smtp_check_reverse_dns(void)
{
	return 0;
}

int smtp_check_reverse_mx_lookup(void)
{
	return 0;
}

int smtp_check_mail_from_self(lm_string_t from, lm_string_t to)
{
	/* Very basic check to compare the two addresses */
	return !LM_STRING_CMP(from, to);
}

